<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <title>Button - jQuery UI</title>
    <script src="../../static/jquery/jquery-3.4.1.js"></script>
    <script src="../../static/jquery/jquery-ui.js"></script>
    <link href="../../static/jquery/jquery-ui.css" rel="stylesheet">
    <link href="../../static/style/common.css" rel="stylesheet">
</head>

<body>
    <div class="content">
        <div id="console" class="console">


        </div>
    </div>
    <script>
        var result;
        $(function() {
            $console = $('#console');
//            var demo = "<?xml version='1.0' encoding='utf-8'?><root><row> <service name='service'>CardStagingAssignCardApplication</service> <func name='func'>getCrdListByID</func> <userId name='userId'>A100010001</userId> <t name='t'>1573725282727</t> <isTransaction name='isTransaction'>true</isTransaction> <lstCardStagingInfo name='lstCardStagingInfo'><list name='list'><originEndDate name='originEndDate'>null</originEndDate> <isTerm name='isTerm'>null</isTerm> <cardChineseName name='cardChineseName'>李元元</cardChineseName> <originAppleDate name='originAppleDate'>null</originAppleDate> <originStartDate name='originStartDate'>null</originStartDate> <originProjectNo name='originProjectNo'>null</originProjectNo> <cardType name='cardType'>信用金融卡</cardType> <cardStatus name='cardStatus'>Y</cardStatus> <originAppleTerm name='originAppleTerm'>null</originAppleTerm> <cardNumber name='cardNumber'>112200112200110</cardNumber> </list><list name='list'><originEndDate name='originEndDate'>null</originEndDate> <isTerm name='isTerm'>null</isTerm> <cardChineseName name='cardChineseName'>蕭風</cardChineseName> <originAppleDate name='originAppleDate'>null</originAppleDate> <originStartDate name='originStartDate'>null</originStartDate> <originProjectNo name='originProjectNo'>null</originProjectNo> <cardType name='cardType'>信用金融卡</cardType> <cardStatus name='cardStatus'>N</cardStatus> <originAppleTerm name='originAppleTerm'>null</originAppleTerm> <cardNumber name='cardNumber'>11220011335030</cardNumber> </list></lstCardStagingInfo> </row></root>";
            var demo = "<?xml version='1.0' encoding='utf-8'?>" +
"<root>"+
"    <row>"+
"        <service name='service'>CardStagingAssignCardApplication</service>"+
"        <func name='func'>getCrdListByID</func>"+
"        <userId name='userId'>A100010001</userId>"+
"        <t name='t'>1573725282727</t>"+
"        <isTransaction name='isTransaction'>true</isTransaction>"+
"        <lstCardStagingInfo name='lstCardStagingInfo'>"+
"            <list name='list'>"+
"                <originEndDate name='originEndDate'>null</originEndDate>"+
"                <isTerm name='isTerm'>null</isTerm>"+
"                <cardChineseName name='cardChineseName'>李元元</cardChineseName>"+
"                <originAppleDate name='originAppleDate'>null</originAppleDate>"+
"                <originStartDate name='originStartDate'>null</originStartDate>"+
"                <originProjectNo name='originProjectNo'>null</originProjectNo>"+
"                <cardType name='cardType'>信用金融卡</cardType>"+
"                <cardStatus name='cardStatus'>Y</cardStatus>"+
"                <originAppleTerm name='originAppleTerm'>null</originAppleTerm>"+
"                <cardNumber name='cardNumber'>112200112200110</cardNumber>"+
"            </list>"+
"            <list name='list'>"+
"                <originEndDate name='originEndDate'>null</originEndDate>"+
"                <isTerm name='isTerm'>null</isTerm>"+
"                <cardChineseName name='cardChineseName'>蕭風</cardChineseName>"+
"                <originAppleDate name='originAppleDate'>null</originAppleDate>"+
"                <originStartDate name='originStartDate'>null</originStartDate>"+
"                <originProjectNo name='originProjectNo'>null</originProjectNo>"+
"                <cardType name='cardType'>信用金融卡</cardType>"+
"                <cardStatus name='cardStatus'>N</cardStatus>"+
"                <originAppleTerm name='originAppleTerm'>null</originAppleTerm>"+
"                <cardNumber name='cardNumber'>11220011335030</cardNumber>"+
"            </list>"+
"        </lstCardStagingInfo>"+
"    </row>"+
"</root>";
  
            var initPageView = function() {
                convertStandardXML(demo);
//                convertStandardXML(customXmlData);
            }
            
            var customXmlData = "<?xml version='1.0' encoding='utf-8'?>" +
                "<root>" +
                "<row>" +
                "<service name='service'>AppInfoService</service>" +
                "<func name='func'>Query</func>" +
                "   <appInfo name='appInfo'>" +
                "       <appName name='appName'>JavaProjSE</appName>" +
                "       <appVersion name='appVersion'>1.0.3</appVersion>" +
                "   </appInfo>" +
                "   <lstAppInfo name='lstAppInfo' type='list'>" +
                "       <appInfo name='appInfo' index='0'>" +
                "           <appName name='appName'>JavaProjSE</appName>" +
                "           <appVersion name='appVersion'>1.0.1</appVersion>" +
                "       </appInfo>" +
                "       <appInfo name='appInfo' index='1'>" +
                "           <appName name='appName'>JUnitSE</appName>" +
                "           <appVersion name='appVersion'>1.0.2</appVersion>" +
                "       </appInfo>" +
                "       <appInfo name='appInfo' index='2'>" +
                "           <appName name='appName'>SpringMVC-SE</appName>" +
                "           <appVersion name='appVersion'>1.0.3</appVersion>" +
                "       </appInfo>" +
                "   </lstAppInfo>" +
                "<appGroup name='appGroup'>" +
                "<appGroupName name='appGroupName'>JavaStudio</appGroupName>" +
                "<appGroupDesc name='appGroupDesc'>Java Project</appGroupDesc>" +
                "</appGroup>" +
                "</row>" +
                "</root>";

            var convertStandardXML = function(xmlResponse) {
                var xmlRow = $(xmlResponse).find('row');

                var setXML2Object = function($parent) {
                    let res = new Object();
                    let len = $parent.children().length;
                    let name, value;
                    let $select = $parent.children().first();

                    for (let i = 0; i < len; i++) {
                        name = $select.attr('name');
                        value = $select.text();

                        if ($select.children().length > 0) {
                            value = setXML2Object($select);
                        }
                        
                        if(name == "list"){
                            if (res[name] == undefined) { // 還是物件，第一個
                                var arrays = new Array();
                                arrays.push(value);
                                res[name] = arrays;
                            } else { // 已經是陣列
                                res[name].push(value);
                            }
                        }else{
                            res[name] = value;
                        }
                        
                        if (i < len - 1) {
                            $select = $select.next();
                        }
                    }
                    return res;
                }

                result = setXML2Object(xmlRow);

                console.log(result);
                console.log(result.lstCardStagingInfo.list.cardType);
                // xmlRow.children().length
                // xmlRow.children()[0]
                // xmlRow.children()[0].textContent
                // xmlRow.children().get(0).getAttribute('name')
                // xmlRow.children().first().text()
            }
            initPageView();
        });

    </script>
</body>

</html>
